/*
Copyright  2005 The Regents of the University of California.
    All Rights Reserved.

    Permission to use, copy, modify, and distribute this software and its
    documentation for educational, research and non-profit purposes,
    without fee, and without a written agreement is hereby granted,
    provided that the above copyright notice, this paragraph and the
    following three paragraphs appear in all copies.

    Permission to incorporate this software into commercial products may
    be obtained by contacting the University of California. For
    information about obtaining such a license contact:

    Chrisanna Waldrop
    Copyright Officer
    805-893-7773
    waldrop@research.ucsb.edu

    This software program and documentation are copyrighted by The Regents
    of the University of California. The software program and
    documentation are supplied "as is", without any accompanying services
    from The Regents. The Regents does not warrant that the operation of
    the program will be uninterrupted or error-free. The end-user
    understands that the program was developed for research purposes and
    is advised not to rely exclusively on the program for any reason.

    IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
    FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
    INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND
    ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN
    ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. THE UNIVERSITY OF
    CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES, INCLUDING, BUT NOT
    LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS"
    BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE
    MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
*/

#ifndef MD_Join_H
#define MD_Join_H

#include <Socket.h>

#include <map>

class MD_Join
{
public:

    MD_Join( short portnumber );

    ~MD_Join() {}

    void JoinGroup( std::string& group );

    void LeaveGroup( std::string& group );

    void SubsribeChannel( std::string& group, std::string& source );
    
    void UnsubscribeChannel(std::string& group, std::string& source );

    void Send( char* buffer, int size, sockaddr_in& address );

	void DisableLoopback();

    void Receive( int timeoutMs, short port, bool waitForMultipleResponse = true );

    int  GetResponseFromMemberCount();

	void SetMulticastTtl( DWORD ttl );

private:
    MD_Socket            m_socket;
 
    typedef std::map<std::string,int>  AddressMap;

    AddressMap  m_responseMap;
};

static unsigned __stdcall SendThreadFunc( void*  pThis )
{
	MD_Join* pJoin = (MD_Join*)pThis;

	char buffer[1024];

	memset( &buffer, 0, 1024 );

	sockaddr_in  addr;

	memset( &addr, 0, sizeof( sockaddr_in ) );

	addr.sin_addr.s_addr = inet_addr( "233.47.77.7" );
	addr.sin_family = AF_INET;
	addr.sin_port = htons( 7777 );

	DWORD duration = 60000;

	DWORD start = GetTickCount();

	while( GetTickCount() - start < 60000 )
	{
		pJoin->Send( buffer, 1024, addr );

		Sleep(500);
	}

	return 0;
}

#endif